diff -ruN orig-e2fsprogs-1.28/debian/control e2fsprogs-1.28/debian/control
--- orig-e2fsprogs-1.28/debian/control	2002-09-24 21:08:58.000000000 +0200
+++ e2fsprogs-1.28/debian/control	2002-09-24 21:44:58.000000000 +0200
@@ -75,6 +75,19 @@
  Don't attempt to install this package, it has no support for a couple of
  features you surely want.  Anyway it should refuse to install.
 
+Package: e2fsprogs-udeb
+Section: debian-installer
+Priority: standard
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: e2fsprogs
+Architecture: any
+Description: A stripped-down versions of e2fsprogs, for debian-installer
+ This package is an e2fsprogs package built for a reduced size, so that
+ it can help to save space in debian-installer.
+ .
+ Don't attempt to install this package, it has no support for a couple of
+ features you surely want.  Anyway it should refuse to install.
+
 Package: e2fsprogs
 Essential: yes
 Pre-Depends: ${shlibs:Depends}
diff -ruN orig-e2fsprogs-1.28/debian/rules e2fsprogs-1.28/debian/rules
--- orig-e2fsprogs-1.28/debian/rules	2002-09-24 20:35:27.000000000 +0200
+++ e2fsprogs-1.28/debian/rules	2002-09-24 22:23:52.000000000 +0200
@@ -44,6 +44,7 @@
 debdir=${topdir}/debian
 tmpdir=${debdir}/tmp
 bfdir=${debdir}/e2fsprogs-bf
+udebdir=${debdir}/e2fsprogs-udeb
 maindir=${debdir}/e2fsprogs
 stdbuilddir=${debdir}/BUILD-STD
 bfbuilddir=${debdir}/BUILD-BF
@@ -52,6 +53,9 @@
 MANDIR=/usr/share/man
 mandir=${tmpdir}${MANDIR}
 
+UDEB_NAME = $(package)-udeb_$(MAIN_VERSION)_$(DEB_HOST_ARCH).udeb
+UDEB_PRIORITY = $(shell grep '^Package: e2fsprogs-udeb' debian/control -A 10 | grep ^Priority: | cut -d ' ' -f 2)
+
 SUBPACKAGES_DIRS = tmp e2fslibs-dev comerr-dev ss-dev
 
 STAMPSDIR=debian/stampdir
@@ -236,12 +240,25 @@
   # remove FSIM for now.
 	rm ${bfdir}/lib/evms/libe2fsim.1.1.1.so
 
+install-udeb: install-bf
+	dh_testdir
+	dh_testroot
+	dh_installdirs
+
+	cp -a ${bfdir}/lib ${udebdir}/
+	mkdir -p ${udebdir}/sbin
+	cp -a ${bfdir}/sbin/mke2fs ${udebdir}/sbin/
+	ln -s mke2fs ${udebdir}/sbin/mkfs.ext2
+	ln -s mke2fs ${udebdir}/sbin/mkfs.ext3
+	cp -a ${bfdir}/sbin/e2fsck ${udebdir}/sbin/
+	ln -s e2fsck ${udebdir}/sbin/fsck.ext2
+	ln -s e2fsck ${udebdir}/sbin/fsck.ext3
 
 binary-indep: 
   # no arch-independant debs.
 
 binary-arch: DH_OPTIONS= -a
-binary-arch: install
+binary-arch: install install-udeb
 	dh_testdir
 	dh_testroot
 
@@ -284,7 +301,7 @@
 	    ${maindir}/usr/share/doc/$$i/copyright ; \
 	done
 
-	dh_installdocs
+	dh_installdocs -Ne2fsprogs-udeb
 
 	install -m 644 debian/e2fsprogs.copyright \
 	  ${bfdir}/usr/share/doc/e2fsprogs-bf/copyright
@@ -346,7 +363,7 @@
 	dh_installdeb
 	dh_shlibdeps -l${stdbuilddir}/lib
 
-	dh_gencontrol -Ncomerr-dev -Nss-dev -Nuuid-dev
+	dh_gencontrol -Ncomerr-dev -Nss-dev -Nuuid-dev -Ne2fsprogs-udeb
 	DH_OPTIONS= dh_gencontrol -pcomerr-dev \
 	  -u '-v${COMERR_VERSION}-${MAIN_VERSION}'
 	DH_OPTIONS= dh_gencontrol -pss-dev \
@@ -354,8 +371,13 @@
 	DH_OPTIONS= dh_gencontrol -puuid-dev \
 	  -u '-v${UUID_VERSION}-${MAIN_VERSION}'
 
-	dh_md5sums
-	dh_builddeb
+	dh_md5sums -Ne2fsprogs-udeb
+	dh_builddeb -Ne2fsprogs-udeb
+
+	# udeb stuff
+	dh_gencontrol	-pe2fsprogs-udeb -- -fdebian/files~
+	dpkg-distaddfile $(UDEB_NAME) debian-installer $(UDEB_PRIORITY)
+	dh_builddeb -pe2fsprogs-udeb --filename=$(UDEB_NAME)
 
 binary: binary-indep binary-arch
 
